// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_admin

import (
	context "context"
	api "gitlab.com/BetaCompany/Freeje/sdk/go/api"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// GatewayClient is the client API for Gateway service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type GatewayClient interface {
	//
	// Получить текущую конфигурацию шлюзов
	// и продолжать мониторинг изменений конфигурации если streamed=1
	GetConfigs(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Gateway_GetConfigsClient, error)
	//
	// Получить текущее состояние шлюзов по инстансам
	// и продолжать мониторинг изменений  если streamed=1
	GetStatus(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Gateway_GetStatusClient, error)
	//
	// Получить текущее состояние шлюзов по инстансам
	// и продолжать мониторинг изменений  если streamed=1
	GatewayCallReport(ctx context.Context, in *GatewayCallRequest, opts ...grpc.CallOption) (Gateway_GatewayCallReportClient, error)
	//
	// Получить полную конфигурацию шлюза заданного в поле id
	GetConfig(ctx context.Context, in *VoipGateway, opts ...grpc.CallOption) (*VoipGateway, error)
	//
	// Обновить данные по шлюзу. В случае если имя шлюза равно null то он будет удален
	Update(ctx context.Context, in *VoipGateway, opts ...grpc.CallOption) (*api.Empty, error)
}

type gatewayClient struct {
	cc grpc.ClientConnInterface
}

func NewGatewayClient(cc grpc.ClientConnInterface) GatewayClient {
	return &gatewayClient{cc}
}

func (c *gatewayClient) GetConfigs(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Gateway_GetConfigsClient, error) {
	stream, err := c.cc.NewStream(ctx, &Gateway_ServiceDesc.Streams[0], "/com.freeje.api.admin.Gateway/GetConfigs", opts...)
	if err != nil {
		return nil, err
	}
	x := &gatewayGetConfigsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Gateway_GetConfigsClient interface {
	Recv() (*VoipGateway, error)
	grpc.ClientStream
}

type gatewayGetConfigsClient struct {
	grpc.ClientStream
}

func (x *gatewayGetConfigsClient) Recv() (*VoipGateway, error) {
	m := new(VoipGateway)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *gatewayClient) GetStatus(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Gateway_GetStatusClient, error) {
	stream, err := c.cc.NewStream(ctx, &Gateway_ServiceDesc.Streams[1], "/com.freeje.api.admin.Gateway/GetStatus", opts...)
	if err != nil {
		return nil, err
	}
	x := &gatewayGetStatusClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Gateway_GetStatusClient interface {
	Recv() (*VoipGatewayStatus, error)
	grpc.ClientStream
}

type gatewayGetStatusClient struct {
	grpc.ClientStream
}

func (x *gatewayGetStatusClient) Recv() (*VoipGatewayStatus, error) {
	m := new(VoipGatewayStatus)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *gatewayClient) GatewayCallReport(ctx context.Context, in *GatewayCallRequest, opts ...grpc.CallOption) (Gateway_GatewayCallReportClient, error) {
	stream, err := c.cc.NewStream(ctx, &Gateway_ServiceDesc.Streams[2], "/com.freeje.api.admin.Gateway/GatewayCallReport", opts...)
	if err != nil {
		return nil, err
	}
	x := &gatewayGatewayCallReportClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Gateway_GatewayCallReportClient interface {
	Recv() (*GatewayCall, error)
	grpc.ClientStream
}

type gatewayGatewayCallReportClient struct {
	grpc.ClientStream
}

func (x *gatewayGatewayCallReportClient) Recv() (*GatewayCall, error) {
	m := new(GatewayCall)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *gatewayClient) GetConfig(ctx context.Context, in *VoipGateway, opts ...grpc.CallOption) (*VoipGateway, error) {
	out := new(VoipGateway)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Gateway/GetConfig", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *gatewayClient) Update(ctx context.Context, in *VoipGateway, opts ...grpc.CallOption) (*api.Empty, error) {
	out := new(api.Empty)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Gateway/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// GatewayServer is the server API for Gateway service.
// All implementations should embed UnimplementedGatewayServer
// for forward compatibility
type GatewayServer interface {
	//
	// Получить текущую конфигурацию шлюзов
	// и продолжать мониторинг изменений конфигурации если streamed=1
	GetConfigs(*api.RequestMode, Gateway_GetConfigsServer) error
	//
	// Получить текущее состояние шлюзов по инстансам
	// и продолжать мониторинг изменений  если streamed=1
	GetStatus(*api.RequestMode, Gateway_GetStatusServer) error
	//
	// Получить текущее состояние шлюзов по инстансам
	// и продолжать мониторинг изменений  если streamed=1
	GatewayCallReport(*GatewayCallRequest, Gateway_GatewayCallReportServer) error
	//
	// Получить полную конфигурацию шлюза заданного в поле id
	GetConfig(context.Context, *VoipGateway) (*VoipGateway, error)
	//
	// Обновить данные по шлюзу. В случае если имя шлюза равно null то он будет удален
	Update(context.Context, *VoipGateway) (*api.Empty, error)
}

// UnimplementedGatewayServer should be embedded to have forward compatible implementations.
type UnimplementedGatewayServer struct {
}

func (UnimplementedGatewayServer) GetConfigs(*api.RequestMode, Gateway_GetConfigsServer) error {
	return status.Errorf(codes.Unimplemented, "method GetConfigs not implemented")
}
func (UnimplementedGatewayServer) GetStatus(*api.RequestMode, Gateway_GetStatusServer) error {
	return status.Errorf(codes.Unimplemented, "method GetStatus not implemented")
}
func (UnimplementedGatewayServer) GatewayCallReport(*GatewayCallRequest, Gateway_GatewayCallReportServer) error {
	return status.Errorf(codes.Unimplemented, "method GatewayCallReport not implemented")
}
func (UnimplementedGatewayServer) GetConfig(context.Context, *VoipGateway) (*VoipGateway, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetConfig not implemented")
}
func (UnimplementedGatewayServer) Update(context.Context, *VoipGateway) (*api.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}

// UnsafeGatewayServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to GatewayServer will
// result in compilation errors.
type UnsafeGatewayServer interface {
	mustEmbedUnimplementedGatewayServer()
}

func RegisterGatewayServer(s grpc.ServiceRegistrar, srv GatewayServer) {
	s.RegisterService(&Gateway_ServiceDesc, srv)
}

func _Gateway_GetConfigs_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(GatewayServer).GetConfigs(m, &gatewayGetConfigsServer{stream})
}

type Gateway_GetConfigsServer interface {
	Send(*VoipGateway) error
	grpc.ServerStream
}

type gatewayGetConfigsServer struct {
	grpc.ServerStream
}

func (x *gatewayGetConfigsServer) Send(m *VoipGateway) error {
	return x.ServerStream.SendMsg(m)
}

func _Gateway_GetStatus_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(GatewayServer).GetStatus(m, &gatewayGetStatusServer{stream})
}

type Gateway_GetStatusServer interface {
	Send(*VoipGatewayStatus) error
	grpc.ServerStream
}

type gatewayGetStatusServer struct {
	grpc.ServerStream
}

func (x *gatewayGetStatusServer) Send(m *VoipGatewayStatus) error {
	return x.ServerStream.SendMsg(m)
}

func _Gateway_GatewayCallReport_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(GatewayCallRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(GatewayServer).GatewayCallReport(m, &gatewayGatewayCallReportServer{stream})
}

type Gateway_GatewayCallReportServer interface {
	Send(*GatewayCall) error
	grpc.ServerStream
}

type gatewayGatewayCallReportServer struct {
	grpc.ServerStream
}

func (x *gatewayGatewayCallReportServer) Send(m *GatewayCall) error {
	return x.ServerStream.SendMsg(m)
}

func _Gateway_GetConfig_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(VoipGateway)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(GatewayServer).GetConfig(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Gateway/GetConfig",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(GatewayServer).GetConfig(ctx, req.(*VoipGateway))
	}
	return interceptor(ctx, in, info, handler)
}

func _Gateway_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(VoipGateway)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(GatewayServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Gateway/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(GatewayServer).Update(ctx, req.(*VoipGateway))
	}
	return interceptor(ctx, in, info, handler)
}

// Gateway_ServiceDesc is the grpc.ServiceDesc for Gateway service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Gateway_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.admin.Gateway",
	HandlerType: (*GatewayServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetConfig",
			Handler:    _Gateway_GetConfig_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _Gateway_Update_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetConfigs",
			Handler:       _Gateway_GetConfigs_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GetStatus",
			Handler:       _Gateway_GetStatus_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GatewayCallReport",
			Handler:       _Gateway_GatewayCallReport_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "admin/gateway.proto",
}
